
## Tighter Privacy Auditing of DP-SGD in the Hidden State Threat Model


To run the experiments, please install the required packages by following the steps below:

1. Due to anonymization, a GitHub repository needs to be initialized. Please run `git init .` in the root directory.

2. Create a fresh conda environment and run `pip install -e .` in the root folder

3. Set a global variable $DSDIR that points to the housing/CIFAR10 dataset.

4. To reproduce the experiments, please run the commands from the `experiments` subfolder:


To reproduce, for example, the performance of A_{GC}-R on CIFAR-10 and a ConvNet model for k=1, run:
```bash
python -u each_epoch_optimal_threshold_attack.py --config-name=hidden_state.yaml data_path=$DSDIR training_params.total_no_of_steps=250 accounting.canary_sampling=every@1 training_params.device=cuda training_params.multidevice=True data=cifar10 model=cnn training_params.batch_size=128
```

To pick a different k, please set the string `every@k` accordingly; for k=5, for example, set it `every@5`. To run the same experiment but using a resnet, set `model=resnet18`, for example:

```bash
python each_epoch_optimal_threshold_attack.py --config-name=hidden_state.yaml data_path=$DSDIR training_params.total_no_of_steps=6250 accounting.canary_sampling=every@25 training_params.device=cuda training_params.multidevice=True data=cifar10 model=resnet18 training_params.batch_size=128 empirical_epsilon.attack_samples=5000
```

runs A_{OG}-R for a Resnet on k=25. If you are interested in running the loss adversary on the same experiment, then set the adversary as follows:

```bash
python -u each_epoch_optimal_threshold_attack.py --config-name=hidden_state.yaml data_path=$DSDIR training_params.total_no_of_steps=6250 accounting.canary_sampling=every@25 training_params.device=cuda training_params.multidevice=True data=cifar10 model=resnet18 training_params.batch_size=128 empirical_epsilon.attack_samples=5000 privacy.C=1 attack=loss training_params.seed=42
```

To run the adversary described in section 6, please run:

```
python breaking_pabi_nonconvex.py
```

Please change the hyperparameters attached to the experiments by changing their associated config file in `experiments/conf`.

