import torch
from torch.nn import Module

from empiricalprivacyestimation.util.loss_fn import get_loss_fn
from empiricalprivacyestimation.util.types import DataPoint


@torch.no_grad()
def loss_attack(cfg, model: Module, point: DataPoint) -> float:
    device = torch.device(cfg.training_params.device)
    x, y = point
    x, y = x.to(device), y.to(device)
    model_output = model(x)
    loss, reduction = get_loss_fn(cfg)
    bce_loss = loss(model_output, y).squeeze().detach()
    return bce_loss.cpu().item()
