from typing import Callable
from typing import Tuple

import torch
from omegaconf import DictConfig
from torch import nn


def get_loss_fn(cfg: DictConfig) -> Tuple[Callable[[torch.Tensor, torch.Tensor], torch.Tensor], str]:
    reduction = cfg.training_params.loss_reduction
    if cfg.attack.name == "loss":
        return nn.CrossEntropyLoss(reduction=reduction), reduction
    elif cfg.model.name == "LogisticRegression":
        return nn.BCEWithLogitsLoss(reduction=reduction), reduction
    elif cfg.model.name == "fcnn":
        return nn.CrossEntropyLoss(reduction=reduction), reduction
    elif cfg.model.name == "cnn":
        return nn.CrossEntropyLoss(reduction=reduction), reduction
    elif cfg.model.name == "alexnet":
        return nn.CrossEntropyLoss(reduction=reduction), reduction
    elif cfg.model.name == "resnet18":
        return nn.CrossEntropyLoss(reduction=reduction), reduction
    elif cfg.model.name == "LogisticRegressionIris":
        return nn.BCEWithLogitsLoss(reduction=reduction), reduction
    raise ValueError("Unknown model")

