from matplotlib import pyplot as plt


def plot_eps_evolution(
    th_eps,
    samples_range,
    results,
    title,
    filename,
):
    plt.xscale("log", base=2)
    plt.xlabel("number of samples")
    plt.axhline(
        y=th_eps,
        color="r",
        linestyle="-",
        label=f"theoretical epsilon={th_eps:.2f}",
    )
    plt.ylim(-1.5, 2 * th_eps + 1.5)

    for k, v in results.items():
        plt.plot(samples_range, v, label=k)

    plt.legend()
    plt.title(title)
    plt.savefig(filename)
    plt.clf()
    plt.cla()
