import numpy
import seaborn
from matplotlib import pyplot as plt

seaborn.set_theme()


def per_step_plot(cfg, steps, results, th_eps, path, title):
    round = lambda arr: numpy.around(arr, decimals=2).astype(numpy.float64)

    for k, v in results.items():
        plt.plot(steps, round(v), label=k)


    if cfg.privacy.compute_epsilons:
        plt.plot(steps, round(th_eps), label="eps", linestyle=":")
        plt.ylim(-1, max(th_eps) * 2)

    plt.xlabel("T")
    plt.legend()
    plt.savefig(f"{path}/{title}")
    plt.cla()
    plt.clf()
