import matplotlib.pyplot as plt
import numpy as np

def plot_privacy_profile(filename, alphas, betas):
    alphas, betas = zip(*sorted(zip(alphas, betas)))
    alphas_perfect = np.linspace(0, 1, 1000)
    betas_perfect = 1 - alphas_perfect
    plt.plot(alphas, betas)
    plt.plot(alphas_perfect, betas_perfect)
    plt.xlim((0, 1))
    plt.ylim((0, 1))
    plt.xlabel("FNR")
    plt.ylabel("FPR")
    plt.savefig(filename)
    plt.cla()
    plt.clf()